/* @pjs pauseOnBlur="true"; */
//import processing.opengl.*;
//Inspiré de : Random Walk by REAS <http://reas.com>
//Tracé d'une marche aléatoire
//Updated Mars 2012 J.ROUSSEL<http://perso.ensc-rennes.fr/jimmy.roussel

int num = 1000;
int range = 6;//longueur de chaque pas aléatoire
int Nmax = 1000;//La procédure s'arr^te après Nmax pas
boolean playing = false;
float[] ax = new float[num];
float[] ay = new float[num]; 
int decompte=0;

void setup() 
{  
  size(300, 320);
  frameRate(50);
  noStroke();
  for (int i=0; i<num; i++) {
    ax[i] = width/2;
    ay[i] = height/2;
  }
  background(0);
  text("", 0, 0);  // force Processing to load a font
  String pausetext = " click to play/pause";
  textSize(20);
  float twidth = textWidth(pausetext);
  text(pausetext, (width-twidth)/2, height/2);
  
}

void draw() {
  if (playing) {
    fill(0);
    rect(0, 0, width, height);
    //mouvement brownien
    // Shift all elements 1 place to the left
    for (int i=1; i<num; i++) {
      ax[i-1] = ax[i];
      ay[i-1] = ay[i];
    }
    // Put a new value at the end of the array
    ax[num-1] += random(-range, range);
    ay[num-1] += random(-range, range);
    // Draw a line connecting the points
    for (int i=1; i<num; i++) {    
      float val = float(i)/num * 255 ;
      stroke(val);
      line(ax[i-1], ay[i-1], ax[i], ay[i]);
    }
    // Write N value 
    noStroke();
    fill(255);
    textSize(10);
    String NvalueText = "N="+decompte;
    float twidth = textWidth(NvalueText);
    text(NvalueText, (width-twidth)/2, height-10);
    decompte+=1;
  }
  if (decompte>Nmax)
  {
    playing=false;
    decompte=0;
    for (int i=0; i<num; i++) {
      ax[i] = width/2;
      ay[i] = height/2;
    }
    noLoop();
  }
}

/*** Start playback */
void play() {
  playing = true;
  loop();
} 
/*** Pause playback */
void pause() {
  playing = false;
  fill(127, 127, 127, 127);
  rect(0, 0, width, height);
  fill(255);
  String pausetext = " click to play/pause";
  textSize(20);
  float twidth = textWidth(pausetext);
  text(pausetext, (width-twidth)/2, height/2);
  textSize(10);
  noLoop();
}


void mouseClicked() {
  if (!playing) { 
    play();
  }
  else { 
    pause();
  }
}








